(defun myerror (s)                  
                                     
  (if (/= s "Function cancelled")
    (princ (strcat "\nError: " s))
  )
  (setvar "cmdecho" ocmd)            
  (setvar "blipmode" oblp)
  (setvar "osmode" oosm)
  (setq *error* olderr)          
  (princ)
)


(defun celica3d (ntimes bpoint raggio chih lppass / ang dist tp ainc dinc dhih distz circle) 
  (setvar "blipmode" 0)             
  (setvar "cmdecho" 0)               
  (setvar "osmode" 0)               
  (setq circle (* 3.141596235 2))
  (setq ainc (/ circle lppass))
  (setq dhih (/ chih lppass))
  (setq ang (- 0.0 ainc))
  (setq distz (- 0.0 dhih))
  (command "_3dpoly")           
  (repeat ntimes 
    (repeat lppass 
      (setq distz (+ distz dhih))
      (setq tp (polar bpoint (setq ang (+ ang ainc)) raggio))
      (setq tp (list (car tp) (cadr tp) distz))
      (command tp)                  
    )
  ) 
  (command "")                 
  (princ)
) 


(defun C:ELICA3D (/ olderr ocmd oblp oosm nt bp bp1 ch lp) 
  (setq olderr  *error*
        *error* myerror)
  (setq ocmd (getvar "cmdecho"))
  (setq oblp (getvar "blipmode"))
  (setq oosm (getvar "osmode"))
  (setvar "cmdecho" 0)
  (initget 1)                         ; bp must not be null
  (setq bp (getpoint "\nPunto centrale: "))
  (initget 3)                         ; bp1 must not be zero or null
  (setq bp1 (getdist "\nRaggio: "))
  (initget 7)                         ; nt must not be zero, neg, or null
  (setq nt (getint "\nNumero di passi: "))
  (initget 3)                         ; cf must not be zero, or null
  (setq ch (getdist "\nAltezza per passo: "))
  (initget 6)                         ; lp must not be zero or neg
  (setq lp (getint "\nPunti per ogni rotazione <30>: "))
  (cond ((null lp) (setq lp 30))) 
  (celica3d nt bp bp1 ch lp)
  (setvar "cmdecho" ocmd)
  (setvar "blipmode" oblp)
  (setvar "osmode" oosm)
  (setq *error* olderr)               ; Restore old *error* handler
  (princ)
) 



